<?php

/**
 * @file gigya_comments.inc
 *
 * Gigya Comments functionality.
 *
 */

/**
 * Helper function to get the gigya comments params for the js.
 * @param int $nid.
 *   the node id
 *
 *  @return array
 *    An associative array containing the comments parmes.
 */
function gigya_comments_ui_parmes($nid) {
  $catid = variable_get('gigya_comments_categoryid', '');
  $cid = variable_get('gigya_comments_container', 'comments');
  $comments_parmes = array(
      'categoryID' => $catid,
      'streamID' => $nid,
      'containerID' => $cid,
      'cid' => '',
  );
  //merge extra parmes from configuration
  $extra_comments = variable_get('gigya_comments_extra', array());
  if (!empty($extra_comments)) {
    array_merge($comments_parmes, $extra_comments);
  }
  // Allow modules to alter the object before adding the JS to the page.
  drupal_alter('gigya_comments', $comments_parmes);

  return $comments_parmes;
}

/**
 * Add the gigya comments ui.
 *
 * @param int $nid.
 */
function gigya_comments_add_ui($nid) {
  drupal_add_js(drupal_get_path('module', 'gigya') . '/js/gigya_comments.js', array('type' => 'file', 'scope' => 'footer'));
  $parms = gigya_comments_ui_parmes($nid);
  drupal_add_js(array('gigya_comments' => array('commentsUIparams' => $parms)), 'setting');
}

/**
 * Handles AJAX requests to the Gigya component.
 */
function gigya_comments_ajax() {
  if (user_access('post comments')) {
    $uid = $_POST['uid'];
    $comment_text = $_POST['commentText'];
    $usig = $_POST['UIDSignature'];
    $timestamp = $_POST['timestamp'];
    $nid = $_POST['nid'];
    //$sec = variable_get('gigya_SecretKey', '');
    //$valid = SigUtils::validateUserSignature($uid, $timestamp, $sec, $usig);
    global $user;
    $user = user_load($uid);
    $comment['name'] = $user->name;
    $comment['nid'] = $nid;
    $comment['is_anonymous'] = 0;
    $comment['status'] = COMMENT_PUBLISHED;
    $comment['language'] = LANGUAGE_NONE;
    $comment['comment_body'] = array(
        LANGUAGE_NONE => array(
            0 => array(
                'value' => $comment_text,
                'format' => 'filtered_html',
            )
        )
    );
    $comm_obj = (object) $comment;
    comment_submit($comm_obj);
    comment_save($comm_obj);
    return drupal_json_output(array('added' => TRUE));
  }
  return drupal_json_output(array('added' => FALSE));
}
